diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/wifi-remote-station-manager.cc ns-3.31/src/wifi/model/wifi-remote-station-manager.cc
--- ns-3.30.1/src/wifi/model/wifi-remote-station-manager.cc	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wifi/model/wifi-remote-station-manager.cc	2020-06-27 17:38:30.000000000 -0700
@@ -33,7 +33,6 @@
 #include "vht-configuration.h"
 #include "he-configuration.h"
 #include "wifi-net-device.h"
-#include "tx-vector-tag.h"
 
 namespace ns3 {
 
@@ -47,16 +46,6 @@
   static TypeId tid = TypeId ("ns3::WifiRemoteStationManager")
     .SetParent<Object> ()
     .SetGroupName ("Wifi")
-    .AddAttribute ("IsLowLatency",
-                   "If true, we attempt to modelize a so-called low-latency device: "
-                   "a device where decisions about tx parameters can be made on a per-packet basis and "
-                   "feedback about the transmission of each packet is obtained before sending the next. "
-                   "Otherwise, we modelize a high-latency device, that is a device where we cannot update "
-                   "our decision about tx parameters after every packet transmission.",
-                   TypeId::ATTR_GET,
-                   BooleanValue (true), //this value is ignored because there is no setter
-                   MakeBooleanAccessor (&WifiRemoteStationManager::IsLowLatency),
-                   MakeBooleanChecker ())
     .AddAttribute ("MaxSsrc",
                    "The maximum number of retransmission attempts for any packet with size <= RtsCtsThreshold. "
                    "This value will not have any effect on some rate control algorithms.",
@@ -158,11 +147,11 @@
   //full set of transmit rates that are supported. We need to know
   //this in order to find the relevant mandatory rates when choosing a
   //transmit rate for automatic control responses like
-  //acknowledgements.
+  //acknowledgments.
   m_wifiPhy = phy;
   m_defaultTxMode = phy->GetMode (0);
   NS_ASSERT (m_defaultTxMode.IsMandatory ());
-  if (GetHtSupported () || GetVhtSupported () || GetHeSupported ())
+  if (GetHtSupported ())
     {
       m_defaultTxMcs = phy->GetMcs (0);
     }
@@ -347,7 +336,7 @@
 }
 
 void
-WifiRemoteStationManager::AddSupportedPlcpPreamble (Mac48Address address, bool isShortPreambleSupported)
+WifiRemoteStationManager::AddSupportedPhyPreamble (Mac48Address address, bool isShortPreambleSupported)
 {
   NS_LOG_FUNCTION (this << address << isShortPreambleSupported);
   NS_ASSERT (!address.IsGroup ());
@@ -513,39 +502,12 @@
   LookupState (address)->m_state = WifiRemoteStationState::DISASSOC;
 }
 
-void
-WifiRemoteStationManager::PrepareForQueue (Mac48Address address, const WifiMacHeader *header, Ptr<const Packet> packet)
-{
-  NS_LOG_FUNCTION (this << address << *header << packet);
-  if (IsLowLatency () || address.IsGroup ())
-    {
-      return;
-    }
-  WifiRemoteStation *station = Lookup (address, header);
-  WifiTxVector rts = DoGetRtsTxVector (station);
-  WifiTxVector data = DoGetDataTxVector (station);
-  WifiTxVector ctstoself = DoGetCtsToSelfTxVector ();
-  HighLatencyDataTxVectorTag datatag;
-  HighLatencyRtsTxVectorTag rtstag;
-  HighLatencyCtsToSelfTxVectorTag ctstoselftag;
-  //first, make sure that the tag is not here anymore.
-  ConstCast<Packet> (packet)->RemovePacketTag (datatag);
-  ConstCast<Packet> (packet)->RemovePacketTag (rtstag);
-  ConstCast<Packet> (packet)->RemovePacketTag (ctstoselftag);
-  datatag = HighLatencyDataTxVectorTag (data);
-  rtstag = HighLatencyRtsTxVectorTag (rts);
-  ctstoselftag = HighLatencyCtsToSelfTxVectorTag (ctstoself);
-  //and then, add it back
-  packet->AddPacketTag (datatag);
-  packet->AddPacketTag (rtstag);
-  packet->AddPacketTag (ctstoselftag);
-}
-
 WifiTxVector
-WifiRemoteStationManager::GetDataTxVector (Mac48Address address, const WifiMacHeader *header, Ptr<const Packet> packet)
+WifiRemoteStationManager::GetDataTxVector (const WifiMacHeader &header)
 {
-  NS_LOG_FUNCTION (this << address << *header << packet);
-  if (!header->IsMgt () && address.IsGroup ())
+  NS_LOG_FUNCTION (this << header);
+  Mac48Address address = header.GetAddr1 ();
+  if (!header.IsMgt () && address.IsGroup ())
     {
       WifiMode mode = GetNonUnicastMode ();
       WifiTxVector v;
@@ -560,15 +522,8 @@
       v.SetStbc (0);
       return v;
     }
-  if (!IsLowLatency ())
-    {
-      HighLatencyDataTxVectorTag datatag;
-      bool found = ConstCast<Packet> (packet)->PeekPacketTag (datatag);
-      NS_ASSERT (found);
-      return datatag.GetDataTxVector ();
-    }
-  WifiTxVector txVector = DoGetDataTxVector (Lookup (address, header));
-  if (header->IsMgt ())
+  WifiTxVector txVector;
+  if (header.IsMgt ())
     {
       //Use the lowest basic rate for management frames
       WifiMode mgtMode;
@@ -582,9 +537,14 @@
         }
       txVector.SetMode (mgtMode);
       txVector.SetPreambleType (GetPreambleForTransmission (mgtMode.GetModulationClass (), GetShortPreambleEnabled (), UseGreenfieldForDestination (address)));
+      txVector.SetTxPowerLevel (m_defaultTxPowerLevel);
       txVector.SetChannelWidth (GetChannelWidthForTransmission (mgtMode, m_wifiPhy->GetChannelWidth ()));
       txVector.SetGuardInterval (ConvertGuardIntervalToNanoSeconds (mgtMode, DynamicCast<WifiNetDevice> (m_wifiPhy->GetDevice ())));
     }
+  else
+    {
+      txVector = DoGetDataTxVector (Lookup (address));
+    }
   Ptr<WifiNetDevice> device = DynamicCast<WifiNetDevice> (m_wifiPhy->GetDevice ());
   Ptr<HeConfiguration> heConfiguration = device->GetHeConfiguration ();
   if (heConfiguration)
@@ -597,22 +557,7 @@
 }
 
 WifiTxVector
-WifiRemoteStationManager::GetCtsToSelfTxVector (const WifiMacHeader *header,
-                                                Ptr<const Packet> packet)
-{
-  NS_LOG_FUNCTION (this << *header << packet);
-  if (!IsLowLatency ())
-    {
-      HighLatencyCtsToSelfTxVectorTag ctstoselftag;
-      bool found = ConstCast<Packet> (packet)->PeekPacketTag (ctstoselftag);
-      NS_ASSERT (found);
-      return ctstoselftag.GetCtsToSelfTxVector ();
-    }
-  return DoGetCtsToSelfTxVector ();
-}
-
-WifiTxVector
-WifiRemoteStationManager::DoGetCtsToSelfTxVector (void)
+WifiRemoteStationManager::GetCtsToSelfTxVector (void)
 {
   WifiMode defaultMode = GetDefaultMode ();
   WifiPreamble defaultPreamble;
@@ -646,10 +591,9 @@
 }
 
 WifiTxVector
-WifiRemoteStationManager::GetRtsTxVector (Mac48Address address, const WifiMacHeader *header,
-                                          Ptr<const Packet> packet)
+WifiRemoteStationManager::GetRtsTxVector (Mac48Address address)
 {
-  NS_LOG_FUNCTION (this << address << *header << packet);
+  NS_LOG_FUNCTION (this << address);
   if (address.IsGroup ())
     {
         WifiMode mode = GetNonUnicastMode ();
@@ -665,14 +609,7 @@
         v.SetStbc (0);
         return v;
     }
-  if (!IsLowLatency ())
-    {
-      HighLatencyRtsTxVectorTag rtstag;
-      bool found = ConstCast<Packet> (packet)->PeekPacketTag (rtstag);
-      NS_ASSERT (found);
-      return rtstag.GetRtsTxVector ();
-    }
-  return DoGetRtsTxVector (Lookup (address, header));
+  return DoGetRtsTxVector (Lookup (address));
 }
 
 void
@@ -680,10 +617,10 @@
 {
   NS_LOG_FUNCTION (this << address << *header);
   NS_ASSERT (!address.IsGroup ());
-  WifiRemoteStation *station = Lookup (address, header);
-  station->m_ssrc++;
+  AcIndex ac = QosUtilsMapTidToAc ((header->IsQosData ()) ? header->GetQosTid () : 0);
+  m_ssrc[ac]++;
   m_macTxRtsFailed (address);
-  DoReportRtsFailed (station);
+  DoReportRtsFailed (Lookup (address));
 }
 
 void
@@ -692,18 +629,18 @@
 {
   NS_LOG_FUNCTION (this << address << *header);
   NS_ASSERT (!address.IsGroup ());
-  WifiRemoteStation *station = Lookup (address, header);
+  AcIndex ac = QosUtilsMapTidToAc ((header->IsQosData ()) ? header->GetQosTid () : 0);
   bool longMpdu = (packetSize + header->GetSize () + WIFI_MAC_FCS_LENGTH) > m_rtsCtsThreshold;
   if (longMpdu)
     {
-      station->m_slrc++;
+      m_slrc[ac]++;
     }
   else
     {
-      station->m_ssrc++;
+      m_ssrc[ac]++;
     }
   m_macTxDataFailed (address);
-  DoReportDataFailed (station);
+  DoReportDataFailed (Lookup (address));
 }
 
 void
@@ -712,32 +649,34 @@
 {
   NS_LOG_FUNCTION (this << address << *header << ctsSnr << ctsMode << rtsSnr);
   NS_ASSERT (!address.IsGroup ());
-  WifiRemoteStation *station = Lookup (address, header);
-  station->m_state->m_info.NotifyTxSuccess (station->m_ssrc);
-  station->m_ssrc = 0;
+  WifiRemoteStation *station = Lookup (address);
+  AcIndex ac = QosUtilsMapTidToAc ((header->IsQosData ()) ? header->GetQosTid () : 0);
+  station->m_state->m_info.NotifyTxSuccess (m_ssrc[ac]);
+  m_ssrc[ac] = 0;
   DoReportRtsOk (station, ctsSnr, ctsMode, rtsSnr);
 }
 
 void
 WifiRemoteStationManager::ReportDataOk (Mac48Address address, const WifiMacHeader *header,
                                         double ackSnr, WifiMode ackMode, double dataSnr,
-                                        uint32_t packetSize)
+                                        WifiTxVector dataTxVector, uint32_t packetSize)
 {
-  NS_LOG_FUNCTION (this << address << *header << ackSnr << ackMode << dataSnr);
+  NS_LOG_FUNCTION (this << address << *header << ackSnr << ackMode << dataSnr << dataTxVector << packetSize);
   NS_ASSERT (!address.IsGroup ());
-  WifiRemoteStation *station = Lookup (address, header);
+  WifiRemoteStation *station = Lookup (address);
+  AcIndex ac = QosUtilsMapTidToAc ((header->IsQosData ()) ? header->GetQosTid () : 0);
   bool longMpdu = (packetSize + header->GetSize () + WIFI_MAC_FCS_LENGTH) > m_rtsCtsThreshold;
   if (longMpdu)
     {
-      station->m_state->m_info.NotifyTxSuccess (station->m_slrc);
-      station->m_slrc = 0;
+      station->m_state->m_info.NotifyTxSuccess (m_slrc[ac]);
+      m_slrc[ac] = 0;
     }
   else
     {
-      station->m_state->m_info.NotifyTxSuccess (station->m_ssrc);
-      station->m_ssrc = 0;
+      station->m_state->m_info.NotifyTxSuccess (m_ssrc[ac]);
+      m_ssrc[ac] = 0;
     }
-  DoReportDataOk (station, ackSnr, ackMode, dataSnr);
+  DoReportDataOk (station, ackSnr, ackMode, dataSnr, dataTxVector.GetChannelWidth (), dataTxVector.GetNss ());
 }
 
 void
@@ -745,9 +684,10 @@
 {
   NS_LOG_FUNCTION (this << address << *header);
   NS_ASSERT (!address.IsGroup ());
-  WifiRemoteStation *station = Lookup (address, header);
+  WifiRemoteStation *station = Lookup (address);
+  AcIndex ac = QosUtilsMapTidToAc ((header->IsQosData ()) ? header->GetQosTid () : 0);
   station->m_state->m_info.NotifyTxFailed ();
-  station->m_ssrc = 0;
+  m_ssrc[ac] = 0;
   m_macTxFinalRtsFailed (address);
   DoReportFinalRtsFailed (station);
 }
@@ -758,55 +698,54 @@
 {
   NS_LOG_FUNCTION (this << address << *header);
   NS_ASSERT (!address.IsGroup ());
-  WifiRemoteStation *station = Lookup (address, header);
+  WifiRemoteStation *station = Lookup (address);
+  AcIndex ac = QosUtilsMapTidToAc ((header->IsQosData ()) ? header->GetQosTid () : 0);
   station->m_state->m_info.NotifyTxFailed ();
   bool longMpdu = (packetSize + header->GetSize () + WIFI_MAC_FCS_LENGTH) > m_rtsCtsThreshold;
   if (longMpdu)
     {
-      station->m_slrc = 0;
+      m_slrc[ac] = 0;
     }
   else
     {
-      station->m_ssrc = 0;
+      m_ssrc[ac] = 0;
     }
   m_macTxFinalDataFailed (address);
   DoReportFinalDataFailed (station);
 }
 
 void
-WifiRemoteStationManager::ReportRxOk (Mac48Address address, const WifiMacHeader *header,
-                                      double rxSnr, WifiMode txMode)
+WifiRemoteStationManager::ReportRxOk (Mac48Address address, double rxSnr, WifiMode txMode)
 {
-  NS_LOG_FUNCTION (this << address << *header << rxSnr << txMode);
+  NS_LOG_FUNCTION (this << address << rxSnr << txMode);
   if (address.IsGroup ())
     {
       return;
     }
-  WifiRemoteStation *station = Lookup (address, header);
-  DoReportRxOk (station, rxSnr, txMode);
+  DoReportRxOk (Lookup (address), rxSnr, txMode);
 }
 
 void
-WifiRemoteStationManager::ReportAmpduTxStatus (Mac48Address address, uint8_t tid,
+WifiRemoteStationManager::ReportAmpduTxStatus (Mac48Address address,
                                                uint8_t nSuccessfulMpdus, uint8_t nFailedMpdus,
-                                               double rxSnr, double dataSnr)
+                                               double rxSnr, double dataSnr, WifiTxVector dataTxVector)
 {
-  NS_LOG_FUNCTION (this << address << +tid << +nSuccessfulMpdus << +nFailedMpdus << rxSnr << dataSnr);
+  NS_LOG_FUNCTION (this << address << +nSuccessfulMpdus << +nFailedMpdus << rxSnr << dataSnr << dataTxVector);
   NS_ASSERT (!address.IsGroup ());
-  WifiRemoteStation *station = Lookup (address, tid);
   for (uint8_t i = 0; i < nFailedMpdus; i++)
     {
       m_macTxDataFailed (address);
     }
-  DoReportAmpduTxStatus (station, nSuccessfulMpdus, nFailedMpdus, rxSnr, dataSnr);
+  DoReportAmpduTxStatus (Lookup (address), nSuccessfulMpdus, nFailedMpdus, rxSnr, dataSnr, dataTxVector.GetChannelWidth (), dataTxVector.GetNss ());
 }
 
 bool
-WifiRemoteStationManager::NeedRts (Mac48Address address, const WifiMacHeader *header,
-                                   Ptr<const Packet> packet, WifiTxVector txVector)
+WifiRemoteStationManager::NeedRts (const WifiMacHeader &header, uint32_t size)
 {
+  NS_LOG_FUNCTION (this << header << size);
+  Mac48Address address = header.GetAddr1 ();
+  WifiTxVector txVector = GetDataTxVector (header);
   WifiMode mode = txVector.GetMode ();
-  NS_LOG_FUNCTION (this << address << *header << packet << mode);
   if (address.IsGroup ())
     {
       return false;
@@ -830,8 +769,8 @@
       NS_LOG_DEBUG ("WifiRemoteStationManager::NeedRTS returning true to protect non-HT stations");
       return true;
     }
-  bool normally = (packet->GetSize () + header->GetSize () + WIFI_MAC_FCS_LENGTH) > m_rtsCtsThreshold;
-  return DoNeedRts (Lookup (address, header), packet, normally);
+  bool normally = (size > m_rtsCtsThreshold);
+  return DoNeedRts (Lookup (address), size, normally);
 }
 
 bool
@@ -860,7 +799,7 @@
     }
   else if (!m_useNonErpProtection)
     {
-      //search for the BSS Basic Rate set, if the used mode is in the basic set then there is no need for Cts To Self
+      //search for the BSS Basic Rate set, if the used mode is in the basic set then there is no need for CTS To Self
       for (WifiModeListIterator i = m_bssBasicRateSet.begin (); i != m_bssBasicRateSet.end (); i++)
         {
           if (mode == *i)
@@ -871,7 +810,7 @@
         }
       if (GetHtSupported ())
         {
-          //search for the BSS Basic MCS set, if the used mode is in the basic set then there is no need for Cts To Self
+          //search for the BSS Basic MCS set, if the used mode is in the basic set then there is no need for CTS To Self
           for (WifiModeListIterator i = m_bssBasicMcsSet.begin (); i != m_bssBasicMcsSet.end (); i++)
             {
               if (mode == *i)
@@ -932,22 +871,22 @@
 {
   NS_LOG_FUNCTION (this << address << packet << *header);
   NS_ASSERT (!address.IsGroup ());
-  WifiRemoteStation *station = Lookup (address, header);
+  AcIndex ac = QosUtilsMapTidToAc ((header->IsQosData ()) ? header->GetQosTid () : 0);
   bool longMpdu = (packet->GetSize () + header->GetSize () + WIFI_MAC_FCS_LENGTH) > m_rtsCtsThreshold;
   uint32_t retryCount, maxRetryCount;
   if (longMpdu)
     {
-      retryCount = station->m_slrc;
+      retryCount = m_slrc[ac];
       maxRetryCount = m_maxSlrc;
     }
   else
     {
-      retryCount = station->m_ssrc;
+      retryCount = m_ssrc[ac];
       maxRetryCount = m_maxSsrc;
     }
   bool normally = retryCount < maxRetryCount;
   NS_LOG_DEBUG ("WifiRemoteStationManager::NeedRetransmission count: " << retryCount << " result: " << std::boolalpha << normally);
-  return DoNeedRetransmission (station, packet, normally);
+  return DoNeedRetransmission (Lookup (address), packet, normally);
 }
 
 bool
@@ -959,10 +898,9 @@
     {
       return false;
     }
-  WifiRemoteStation *station = Lookup (address, header);
   bool normally = (packet->GetSize () + header->GetSize () + WIFI_MAC_FCS_LENGTH) > GetFragmentationThreshold ();
   NS_LOG_DEBUG ("WifiRemoteStationManager::NeedFragmentation result: " << std::boolalpha << normally);
-  return DoNeedFragmentation (station, packet, normally);
+  return DoNeedFragmentation (Lookup (address), packet, normally);
 }
 
 void
@@ -1118,28 +1056,12 @@
 }
 
 WifiRemoteStation *
-WifiRemoteStationManager::Lookup (Mac48Address address, const WifiMacHeader *header) const
-{
-  uint8_t tid;
-  if (header->IsQosData ())
-    {
-      tid = header->GetQosTid ();
-    }
-  else
-    {
-      tid = 0;
-    }
-  return Lookup (address, tid);
-}
-
-WifiRemoteStation *
-WifiRemoteStationManager::Lookup (Mac48Address address, uint8_t tid) const
+WifiRemoteStationManager::Lookup (Mac48Address address) const
 {
-  NS_LOG_FUNCTION (this << address << +tid);
+  NS_LOG_FUNCTION (this << address);
   for (Stations::const_iterator i = m_stations.begin (); i != m_stations.end (); i++)
     {
-      if ((*i)->m_tid == tid
-          && (*i)->m_state->m_address == address)
+      if ((*i)->m_state->m_address == address)
         {
           return (*i);
         }
@@ -1148,9 +1070,6 @@
 
   WifiRemoteStation *station = DoCreateStation ();
   station->m_state = state;
-  station->m_tid = tid;
-  station->m_ssrc = 0;
-  station->m_slrc = 0;
   const_cast<WifiRemoteStationManager *> (this)->m_stations.push_back (station);
   return station;
 }
@@ -1343,15 +1262,17 @@
   m_stations.clear ();
   m_bssBasicRateSet.clear ();
   m_bssBasicMcsSet.clear ();
+  m_ssrc.fill (0);
+  m_slrc.fill (0);
 }
 
 void
 WifiRemoteStationManager::AddBasicMode (WifiMode mode)
 {
   NS_LOG_FUNCTION (this << mode);
-  if (mode.GetModulationClass () == WIFI_MOD_CLASS_HT || mode.GetModulationClass () == WIFI_MOD_CLASS_VHT || mode.GetModulationClass () == WIFI_MOD_CLASS_HE)
+  if (mode.GetModulationClass () >= WIFI_MOD_CLASS_HT)
     {
-      NS_FATAL_ERROR ("It is not allowed to add a HT, VHT or HE rate in the BSSBasicRateSet!");
+      NS_FATAL_ERROR ("It is not allowed to add a HT rate in the BSSBasicRateSet!");
     }
   for (uint8_t i = 0; i < GetNBasicModes (); i++)
     {
@@ -1465,7 +1386,7 @@
 
 bool
 WifiRemoteStationManager::DoNeedRts (WifiRemoteStation *station,
-                                     Ptr<const Packet> packet, bool normally)
+                                     uint32_t size, bool normally)
 {
   return normally;
 }
@@ -1485,7 +1406,7 @@
 }
 
 void
-WifiRemoteStationManager::DoReportAmpduTxStatus (WifiRemoteStation *station, uint8_t nSuccessfulMpdus, uint8_t nFailedMpdus, double rxSnr, double dataSnr)
+WifiRemoteStationManager::DoReportAmpduTxStatus (WifiRemoteStation *station, uint8_t nSuccessfulMpdus, uint8_t nFailedMpdus, double rxSnr, double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss)
 {
   NS_LOG_DEBUG ("DoReportAmpduTxStatus received but the manager does not handle A-MPDUs!");
 }
@@ -1508,7 +1429,7 @@
 WifiRemoteStationManager::GetNonErpSupported (const WifiRemoteStation *station, uint8_t i) const
 {
   NS_ASSERT (i < GetNNonErpSupported (station));
-  //IEEE 802.11g standard defines that if the protection mechanism is enabled, Rts, Cts and Cts-To-Self
+  //IEEE 802.11g standard defines that if the protection mechanism is enabled, RTS, CTS and CTS-To-Self
   //frames should select a rate in the BSSBasicRateSet that corresponds to an 802.11b basic rate.
   //This is a implemented here to avoid changes in every RAA, but should maybe be moved in case it breaks standard rules.
   uint32_t index = 0;
